=== debian/changelog ===
spring (0.82.5.1+dfsg1-1ubuntu2) maverick; urgency=low

  * debian/control: 
    - conflict with older spring-engine to ease lucid upgrades (LP: #647380)

 -- Scott Ritchie <scottritchie@ubuntu.com>  Tue, 28 Sep 2010 23:38:14 -0700

spring (0.82.5.1+dfsg1-1ubuntu1) maverick; urgency=low

  * Latest upstream version for online play
  * debian/control: Replace (rather than conflict) spring-engine
    - spring-engine will be a dummy package (LP: #612905)
    - also set maintainer to MOTU

 -- Scott Ritchie <scottritchie@ubuntu.com>  Thu, 23 Sep 2010 18:56:03 -0700

spring (0.82.5.1+dfsg1-1) experimental; urgency=low

  * New upstream version.
  * debian/control: add Suggests: libtxc-dxtn0 (Closes: #595379)
  * update debian/patches/0006-fix-spelling-error.patch fix spelling
    error in doc/manpages/spring-headless.6.txt
  * remove debian/spring.links upstream provides man pages for binaries

 -- Jan Dittberner <jandd@debian.org>  Wed, 08 Sep 2010 19:52:39 +0200

spring (0.82.3+dfsg1-1) experimental; urgency=low

  * New upstream version.
  * remove debian/patches/0001-Minor-spelling-fix.patch it is not needed
    anymore
  * refresh patch debian/patches/0002-use-Debian-java-libs.patch
  * debian/control: bump Standards-Version to 3.9.1 (no changes needed)
  * add debian/patches/0005-fix-sdl-build.patch to use libsdl1.2-dev's
    header files
  * update debian/rules and debian/docs to use new upstream
    documentation paths
  * update debian/README.source and debian/rules to reflect the removal
    of Windows binary files from upstream tarball
  * add debian/patches/0006-fix-spelling-error.patch to fix a spelling
    error
  * add symlinks to spring manpage for spring-multithreaded, spring-headless
    and spring-dedicated binaries
  * remove include/SDL and include/GL

 -- Jan Dittberner <jandd@debian.org>  Sun, 15 Aug 2010 17:49:08 +0200
